/****************************************************
 * charDev5.c is the corresponding driver. Used to  *
 * print the content of cr3 and pgd                 *
 * **************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include "cd4.h"

#define MAX 4096

int main() {
    int fd, size, i ;
    char buff[MAX], *pgdP ;
    pageDirBase pdb ;
    
    fd = open("/dev/myCharDev", O_RDONLY, 0666) ;
    read(fd, buff, MAX) ;

    pgdP = (char *) &pdb ;
    size = sizeof(pageDirBase) ;
    for(i = 0; i<size; ++i) pgdP[i] = buff[i] ;
    
    printf("cr3: %p, pgd: %p\n", (int *)pdb.cr3, (int *)pdb.pgdP) ;

    return 0 ;
}
