/****************************************************
 * charDev6.c is the corresponding driver. Used to  *
 * print the content of cr3 and pgd                 *
 * **************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include "cd5.h"

#define MAX 4096

int main() {
    int fd, i, size ;
    char buff[MAX], *tP ;
    pagetable t ;
    
    fd = open("/dev/myCharDev", O_RDONLY, 0666) ;
    sprintf(buff, "%d ", (int) main) ;

    printf("fd: %d\n", fd) ;
    printf("main(): %p\n", main) ;

    read(fd, buff, MAX) ;

    tP = (char *) &t ;
    size = sizeof(pagetable) ;
    for(i = 0; i<size; ++i) tP[i] = buff[i] ;
    
    printf("inAddress: %p\n", (int *)t.inAddr) ;
    printf("\tControl Register (cr3): %p\n\tPage Directory Base: %p\n", 
            (int *)t.cr3, (int *)t.pgdP) ;
    printf("\tPage Directory Offset: %p\n", (int *)t.pgdOff) ;
    printf("\tPage Directory Entry: %p\n", (int *)t.pgdEnt) ;
    printf("\tPage Table Offset: %p\n", (int *)t.pteOff) ;
    printf("\tPage Table Entry: %p\n", (int *)t.pEnt) ;
    printf("\tKernel address: %p for the User address: %p\n", 
            (int *) t.kAddr, (int *)t.inAddr) ;
    printf("A few machine code: ") ;
    for(i=0; i<SIZE; ++i) 
            printf("%x ", (0x000000ff & t.code[i])) ;
    printf("\n") ;    

 return 0 ;
}
